// OBoard.cpp: implementation of the OBoard class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Othello.h"
#include "OBoard.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OBoard::OBoard()
{
	moveSequence [0] = BADMOVE;
	bSoundEnabled = true;
}

OBoard::~OBoard()
{

}

void OBoard::Reset()
{
	for( int i =0; i <= 63; i++)
	{
		Board[i] = NONE;
		MovesPossible[i]=false;
	}

	Board[28] = Board[35] = WHITE;
	Board[27] = Board[36] = BLACK;



	
	//update the Board
/*	disp.show_piece(28, 2);
	disp.show_piece(27, 1);
	disp.show_piece(36, 1);
	disp.show_piece(35, 2);*/
	
}

nPos* OBoard::getBoard()
{
	return Board;
}

void OBoard::playmove(nID who, nMoveLocation location)
{
	int m = location;
	ASSERT( isLegal(who, m) ); //***DEBUG
	int nMoves = 0;	
	
	Board[m] = who;
	moveSequence[nMoves++] = m;
	//movesequence contains the changes to be made on the Board
	
//	disp.show_piece(m, who);
	
	
	int r = m/8, c = m%8;
	nID opp = 3 - who;

	if (c<=5)
		if (Board[m+1]==opp)
			for ( int i=m+2; i%8!=0; i++)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m+1; j!=i ; j++)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) MessageBeep(0xFFFFFFFF);
						}
				break;  //do nothing for blank space
				}
	if (c>=2)
		if (Board[m-1]==opp)
			for ( int i=m-2; i%8!=7 && i!=-1; i--)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m-1; j!=i; j--)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) 
							MessageBeep (0xFFFFFFFF);
						}
				break;
				}
	if (r>=2)
		if (Board[m-8]==opp)
			for ( int i=m-16; i>=0 ; i-=8)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m-8; j!=i; j-=8)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) MessageBeep(0xFFFFFFFF);
						}
				break;
				}
	if (r<=5)
		if (Board[m+8]==opp)
			for ( int i=m+16; i<=63 ; i+=8)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m+8; j!=i; j+=8)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) MessageBeep(0xFFFFFFFF);
						}
				break;
				}
	if (r<=5 && c<=5)
		if (Board[m+9]==opp)
			for ( int i=m+18; (i<=63) && ((i%8)!=0) ; i+=9)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m+9; j!=i; j+=9)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) MessageBeep(0xFFFFFFFF);
						}
				break;
				}
	if (r<=5 && c>=2)
		if (Board[m+7]==opp)
			for ( int i=m+14; (i<=63) && ((i%8)!=7) ; i+=7)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m+7; j!=i; j+=7)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) MessageBeep(0xFFFFFFFF);
						}
				break;
				}
	if (r>=2 && c<=5)
		if (Board[m-7]==opp)
			for ( int i=m-14; i>=0 && i%8 != 0 ; i-=7)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m-7; j!=i; j-=7)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) MessageBeep(0xFFFFFFFF);
						}
				break;
				}
	if (r>=2 && c>=2)
		if (Board[m-9]==opp)
			for ( int i=m-18; (i>=0) && ((i%8)!=7) ; i-=9)
				{
				if (Board[i] == opp) continue;
				if (Board[i]==who)
					for (int j=m-9; j!=i ; j-=9)
						{
						Board[j] = who;
						moveSequence[nMoves++] = j;
						if (bSoundEnabled) MessageBeep(0xFFFFFFFF);
						}
				break;
				}
	
	moveSequence[nMoves] = -1;

}

nPos* OBoard::getMoveSequence()
{
	return moveSequence;
}

bool OBoard::isLegal (nID who, nMoveLocation m)
{
	if (Board[m]) return false;

	int r = m/8, c = m%8;
	nID opp = 3 - who;

	if (c<=5)
		if (Board[m+1]==opp)
			for ( int i=m+2; i%8!=0; i++)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;
	if (c>=2)
		if (Board[m-1]==opp)
			for ( int i=m-2; i%8!=7 && i!=-1; i--)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;
	if (r>=2)
		if (Board[m-8]==opp)
			for ( int i=m-16; i>=0 ; i-=8)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;
	if (r<=5)
		if (Board[m+8]==opp)
			for ( int i=m+16; i<=63 ; i+=8)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;
	if (r<=5 && c<=5)
		if (Board[m+9]==opp)
			for ( int i=m+18; (i<=63) && ((i%8)!=0) ; i+=9)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;
	if (r<=5 && c>=2)
		if (Board[m+7]==opp)
			for ( int i=m+14; (i<=63) && ((i%8)!=7) ; i+=7)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;
	if (r>=2 && c<=5)
		if (Board[m-7]==opp)
			for ( int i=m-14; i>=0 && i%8 != 0 ; i-=7)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;
	if (r>=2 && c>=2)
		if (Board[m-9]==opp)
			for ( int i=m-18; (i>=0) && ((i%8)!=7) ; i-=9)
				if (Board[i]==who) return true;
				else if (Board[i]==0) break;

	return false;

}

int OBoard::nLegalMoves(nID who)
{
	int to_return=0;

	for(int i=0; i<=63; i++)
		if (isLegal(who, i)) to_return++;

	return to_return;

}

int OBoard::nPieces(nID who)
{
	int to_return=0;
	for (int i=0; i<=63; i++)
		to_return += ( (Board[i]==who)? 1 : 0 );
	return to_return;

}

bool OBoard::isFilled()
{
	for(int i=0; i<=63; i++)
		if (Board[i] == 0) return false;
	return true;

}

CString * OBoard::getDumpString()
{
	return &sDump;

}

int OBoard::MarkPossibleMoves(nID who)
{
	nMovesPossible = 0;
	

	//indicate possible moves
	for(int i=0; i<=63; i++)
		if ( isLegal(who, i) )
			{
			MovesPossible[i] = true;//Display Possible Move
			nMovesPossible ++;
			}
		else MovesPossible [i] = false;

	return 	nMovesPossible;
}

bool* OBoard::getListofPossibleMoves()
{
	return MovesPossible;
}
