// OthelloView.cpp : implementation of the COthelloView class
//

#include "stdafx.h"
#include "Othello.h"

#include "OthelloDoc.h"
#include "OthelloView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COthelloView

IMPLEMENT_DYNCREATE(COthelloView, CScrollView)

BEGIN_MESSAGE_MAP(COthelloView, CScrollView)
	//{{AFX_MSG_MAP(COthelloView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_OPTIONS_PLAYERSETTINGS, OnOptionsPlayersettings)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_A_COMPUTER, OnRadioPlayerAComputer)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_A_HUMAN, OnRadioPlayerAHuman)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_B_COMPUTER, OnRadioPlayerBComputer)
	ON_BN_CLICKED(IDC_RADIO_PLAYER_B_HUMAN, OnRadioPlayerBHuman)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_VIEW_ANIMATION, OnViewAnimation)
	ON_COMMAND(ID_VIEW_INDICATEPOSSIBLEMOVES, OnViewIndicatepossiblemoves)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COthelloView construction/destruction

COthelloView::COthelloView()
{
	// TODO: add construction code here
	bmpBoard.LoadBitmap(IDB_BOARD);
	bmpBlob.LoadBitmap(IDB_TRANSITION);
	//load the board an disc bitmaps from resource space
	
	ShowTransition = true;
	IndicatePossibleMoves = true;
	//enable animation-piece turning effect
	
	BitmapOffset.x = 32;
	BitmapOffset.y = 34;
	/*this is the actual offset till the 
	board boundary from the bitmap boundary-
	this is bitmap dependant*/

	BitmapCellWidth = 44;
	//the square size in the board-bitmap dependant again
	ResetGame();
	waitingForHumanMove = false;
	humanMove=-1;

	BrainForHint.set_depth(2);
	BrainForHint.set_endgame_empty(1);
	
	
}

COthelloView::~COthelloView()
{
}

BOOL COthelloView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	
	





	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COthelloView drawing

void COthelloView::OnDraw(CDC* pDC)
{
	// TODO: add draw code for native data here
	CDC dcmem;
	dcmem.CreateCompatibleDC(pDC);
	CBitmap *oldBitmap=dcmem.SelectObject(&bmpBoard);

	pDC->BitBlt(0,0,640,480,&dcmem,0,0,SRCCOPY);
	int cell, rows, columns;
	nPos* Board = Game.getBoard (); 
	bool *MovesPossible = Game.getListofPossibleMoves ();
	CPoint Where;
	cell = 0;
	for ( rows = 7 ; rows >=0; rows--)
		for (columns = 0; columns < 8 ; columns++)
		{
	Where.x = columns * BitmapCellWidth;
	Where.y = rows * BitmapCellWidth;
	Where += BitmapOffset;

	
		switch	(Board[cell])
		{
		case NONE://Not	Reqd. as the whole board is being redrawn
			
		if (IndicatePossibleMoves && MovesPossible [cell])
		{
			pDC->SetROP2(R2_XORPEN);
			pDC->Ellipse (Where.x+15, Where.y +15, Where.x + BitmapCellWidth-15, Where.y + BitmapCellWidth-15);
		}		
			break;
		case BLACK:
			dcmem.SelectObject(&bmpBlob);
			pDC->BitBlt( Where.x + 2,Where.y + 2,BitmapCellWidth - 2,BitmapCellWidth - 2,&dcmem,BitmapCellWidth * 10 + 2, 2, SRCPAINT);
			break;
		case WHITE:
			dcmem.SelectObject(&bmpBlob);
			pDC->BitBlt( Where.x + 2,Where.y + 2,BitmapCellWidth - 2,BitmapCellWidth - 2,&dcmem,BitmapCellWidth * 0 + 2, 2, SRCPAINT);
			break;
		
		}
		cell++;
	}
	nPos move = Game.getLastMove ();

	if (IndicatePossibleMoves && move >= 0)
	{
		
		Where.x = move%8 * BitmapCellWidth;
		Where.y = (7 - move/8) * BitmapCellWidth;
		Where += BitmapOffset;
		pDC->SetROP2 (R2_COPYPEN);
		pDC->SelectStockObject(WHITE_PEN);
		pDC->Ellipse (Where.x + 3, Where.y + 3, Where.x + 9, Where.y + 9);
		//pDC->Rectangle (Where.x+2, Where.y+2, Where.x + BitmapCellWidth-1, Where.y + BitmapCellWidth-1);
	}
	RefreshMoveList ();		

	dcmem.SelectObject(oldBitmap);
}

void COthelloView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	// TODO: calculate the total size of this view
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
	

}

/////////////////////////////////////////////////////////////////////////////
// COthelloView diagnostics

#ifdef _DEBUG
void COthelloView::AssertValid() const
{
	CScrollView::AssertValid();
}

void COthelloView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

COthelloDoc* COthelloView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COthelloDoc)));
	return (COthelloDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COthelloView message handlers

void COthelloView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	CScrollView::OnMouseMove(nFlags, point);
}

void COthelloView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	
	if (!waitingForHumanMove) goto EndofEvent;


	/*
	

	// TODO: Add your message handler code here and/or call default
	if (Game.isBusy() || Game.getCurrentPlayerType() == COMPUTER )
	{
		//MessageBox(GetTopWindow(),"You Fool! Let the Computer Play Sometimes...","Advise", MB_OK);
		goto EndofEvent;
	}
	*/
	point.x -= BitmapOffset.x;
	point.y -= BitmapOffset.y;
	if ( point.x < 0 || point.y < 0)
	{
		MessageBeep (0xFFFFFFFF);
		goto EndofEvent;
	}
	point.x /= BitmapCellWidth;
	point.y /= BitmapCellWidth;
	if ( point.x > 7 || point.y >7)
	{
		MessageBeep (0xFFFFFFFF);
		goto EndofEvent;
	}

	humanMove = (7-point.y)*8 + point.x;

	if (Game.tryMove (humanMove))
	{

		MainLoop ();//send user defind message to mainloop

	}


	//{
//		if (Game.Play(move) == false)
	//	{// returning false means that game has ended
			//tk: code for end of game
	//	}
		
	//	CellState cellState = Game.getCurrentPlayerType();

	//	ShowCellStateChange ( point, cellState);

	//	}

EndofEvent:
	CScrollView::OnLButtonDown(nFlags, point);
}




void COthelloView::ShowCellStateChange(CPoint location, nID toCellState)
{
	int i;
	CClientDC *pDC = new CClientDC (this);
	CBitmap *oldBitmap;
	CDC dcmem;
	dcmem.CreateCompatibleDC(pDC);
	CPoint Where = BitmapOffset;
	Where.x += location.x * BitmapCellWidth;
	Where.y += location.y * BitmapCellWidth;
		
	oldBitmap=dcmem.SelectObject(&bmpBoard);
	switch (toCellState)	{
	case NONE:
		pDC->BitBlt( Where.x,Where.y,BitmapCellWidth,BitmapCellWidth, &dcmem,Where.x, Where.y, SRCCOPY);
		break;
	case BLACK:
		if (ShowTransition == false)
		{
			i = 10;
			dcmem.SelectObject(&bmpBoard);
			pDC->BitBlt( Where.x,Where.y,BitmapCellWidth,BitmapCellWidth,&dcmem,Where.x, Where.y, SRCCOPY);
			dcmem.SelectObject(&bmpBlob);
			pDC->BitBlt( Where.x + 2,Where.y + 2,BitmapCellWidth - 2,BitmapCellWidth - 2,&dcmem,BitmapCellWidth * i + 2, 2, SRCPAINT);
			break;
		}
		
		for(i = 0; i < 11; i++)
		{
			dcmem.SelectObject(&bmpBoard);
			pDC->BitBlt( Where.x,Where.y,BitmapCellWidth,BitmapCellWidth,&dcmem,Where.x, Where.y, SRCCOPY);
			dcmem.SelectObject(&bmpBlob);
			pDC->BitBlt( Where.x + 2,Where.y + 2,BitmapCellWidth - 2,BitmapCellWidth - 2,&dcmem,BitmapCellWidth * i + 2, 2, SRCPAINT);
			::Sleep (20);
		}		
		break;
	case WHITE:
		if (ShowTransition == false)
		{
			i = 0;
			dcmem.SelectObject(&bmpBoard);
			pDC->BitBlt( Where.x,Where.y,BitmapCellWidth,BitmapCellWidth,&dcmem,Where.x, Where.y, SRCCOPY);
			dcmem.SelectObject(&bmpBlob);
			pDC->BitBlt( Where.x + 2,Where.y + 2,BitmapCellWidth - 2,BitmapCellWidth - 2,&dcmem,BitmapCellWidth * i + 2, 2, SRCPAINT);
			break;
		}
		else
		for(i = 11; i > 0; i--)
		{
			dcmem.SelectObject(&bmpBoard);
			pDC->BitBlt( Where.x,Where.y,BitmapCellWidth,BitmapCellWidth,&dcmem,BitmapOffset.x, BitmapOffset.y, SRCCOPY);
			dcmem.SelectObject(&bmpBlob);
			pDC->BitBlt( Where.x + 2,Where.y + 2,BitmapCellWidth - 2,BitmapCellWidth - 2,&dcmem,BitmapCellWidth * i + 2, 2, SRCPAINT);
			::Sleep (20);
		}		
		break;
	}

	dcmem.SelectObject(oldBitmap);
}


void COthelloView::OnOptionsPlayersettings() 
{
	// TODO: Add your command handler code here
	
	UpdateData(false);
	playerSettings.DoModal ();
	UpdateData(true);
	Invalidate(true);
	UpdateGameSettings();
	if (waitingForHumanMove = true && Game.getCurrentPlayerType() == COMPUTER)
	{
		waitingForHumanMove = false;
		MainLoop();
	}
	if (waitingForHumanMove == false && Game.getCurrentPlayerType() == HUMAN)
		waitingForHumanMove=true;
}

void COthelloView::OnRadioPlayerAComputer() 
{
	// TODO: Add your control notification handler code here
	
}

void COthelloView::OnRadioPlayerAHuman() 
{
	// TODO: Add your control notification handler code here
	
}

void COthelloView::OnRadioPlayerBComputer() 
{
	// TODO: Add your control notification handler code here
	
}

void COthelloView::OnRadioPlayerBHuman() 
{
	// TODO: Add your control notification handler code here
	
}

void COthelloView::OnFileNew() 
{
	// TODO: Add your command handler code here
	GetParent()->SetWindowText("Gothello: The Expert Othello Automaton");
	ResetGame();
	waitingForHumanMove = false;
	CString title;
	UpdateData (false);
	/*title = "Gothello: " + playerSettings.m_PlayerA + " vs " + playerSettings.m_PlayerB;
	GetParent()->SetWindowText ("Gothello: The Expert Othello Automaton");*/
	MainLoop ();

}

void COthelloView::ResetGame()
{
	Game.resetGame ();
	moveList.Reset();
	UpdateGameSettings();
}

void COthelloView::UpdateGameSettings()
{
	Game.Set(playerSettings.m_PlayerA,
		(playerSettings.m_RadioPlayerAHuman == 0)? HUMAN : COMPUTER,
		playerSettings.m_SearchDepth_A, 
		playerSettings.m_PerfectDepth_A,
		playerSettings.m_PlayerB,
		(playerSettings.m_RadioPlayerBHuman == 0)? HUMAN : COMPUTER,
		playerSettings.m_SearchDepth_B, 
		playerSettings.m_PerfectDepth_B);

}



void COthelloView::MainLoop()
{
	int CurrentPlayer = Game.GetCurrentPlayer();
	CClientDC * pDC = new CClientDC(this);

	if (waitingForHumanMove && humanMove != -1)
	{
		waitingForHumanMove = false;		
		Game.playMove(humanMove); 
		moveList.addMove (humanMove);
		RefreshMoveList ();


		humanMove=-1;
		AnimateMove(CurrentPlayer);
		BrainForHint.set_id(CurrentPlayer, 
			(CurrentPlayer==WHITE)? BLACK : WHITE,
			NONE);
		nMoveLocation Hint = BrainForHint.make_move(
			Game.getBoard());

		//display



		CurrentPlayer = Game.switchPlayer();

		
	}
Restart:

	int t1 = Game.nLegalMoves(CurrentPlayer);
	int t2 = Game.nLegalMoves(
		     (CurrentPlayer==WHITE)? BLACK : WHITE);

	if (t1==0 && t2==0)
	{		//game over
		t1 = Game.nPieces(CurrentPlayer);
		t2 = Game.nPieces((CurrentPlayer==WHITE)? BLACK : WHITE);

		char str[100];

		if (t1==t2)
			sprintf(str, "GAME DRAWN!!");
		else if (t1>t2)
			sprintf(str, "%s has won the game by %d-%d=%d pieces!!", 
				Game.getPlayerName(), t1, t2, t1-t2);
		else
			sprintf(str, "%s has won the game by %d-%d=%d pieces!!", 
				Game.getPlayerName((CurrentPlayer==WHITE)? BLACK : WHITE), 
				t2, t1, t2-t1);
		
		MessageBox(str, "Result", MB_OK);
		waitingForHumanMove = false;
		return;
	}

	if (t1)
	{
		BeginWaitCursor ();
		Game.MarkPossibleMoves();
		//CClientDC *pDC = ;
		OnDraw (new CClientDC(this));
		//OnDraw(   );Invalidate (true);
		//call display function

		if (Game.getCurrentPlayerType()==HUMAN)
		{ waitingForHumanMove = true;
			EndWaitCursor ();

		  return;
		}

		nMoveLocation move = Game.getComputerMove();
		CString str;
		float nNodesperSec;
		long nNodesEvaluated = Game.getNodesEvaluated();
		long tElapsed = Game.getElapsedTime ();
		nNodesperSec = (float)nNodesEvaluated/tElapsed;
		str.Format("Nodes Evaluated: %ld    Time Elapsed: %ldms    ", nNodesEvaluated, tElapsed);
				
		
		pDC->TextOut(10,420, str);
		str.Format("Nodes per Second: %.1fKnodes/sec    ", nNodesperSec);
		pDC->TextOut(10,435, str);
		nScore score = Game.getCurrentScore ();
		//if (score < 
		str.Format("Score:  %d    ", score);
		pDC->TextOut(10,450, str);
		str.Format("Prediction:");
		if (score < 100000 && score > -100000)
			str += "No Prediction Yet                         ";
		else if(score <-100000)
		{
			str = str +" " + Game.getPlayerName ()+ " will LOSE by a maximum of ";
		CString temp;
		temp.Format("%d discs     ", -score-100000);
		str +=temp;
		}
		else if(score > 100000)
		{
			str = str +" " + Game.getPlayerName ()+ " will WIN at least by";
		CString temp;
		temp.Format("%d discs    ", score-100000);
		str +=temp;
		}

		pDC->TextOut(10,465, str);

		Game.playMove(move);
		moveList.addMove (move);
		RefreshMoveList ();


		AnimateMove(CurrentPlayer);
		//call display function
		CurrentPlayer = Game.switchPlayer();
		
		MSG userMessage;
		if ((PeekMessage(&userMessage, (HWND)this, WM_CHAR, WM_CHAR, PM_REMOVE)))
			OnFileNew();
		
		//	ResetGameMessageBeep (0xFFFFFFFF);
			//OnDraw ( new CClientDC (this));
		else
			
		goto Restart;
	}
	else
	{
		char str[100];
		sprintf(str, "%s has no move to play!", Game.getPlayerName());
		MessageBox(str, "Result", MB_OK);
		
		CurrentPlayer = Game.switchPlayer();
		goto Restart;
	
	}
}


void COthelloView::AnimateMove(nID toWhat)
{
	nPos* moveSequence = Game.getLastMoveSequence ();
	if(moveSequence[0] < 0)
		return;
	Invalidate (false);

	CPoint loc;
	loc.x = moveSequence[0]%8; loc. y = 7 - moveSequence[0]/8;
	bool bTemp = ShowTransition;
	ShowTransition = false;
	ShowCellStateChange(loc, toWhat);
	int i = 1;
	ShowTransition = bTemp;
	while ( moveSequence [i]>=0)
	{
		loc.x = moveSequence[i]%8; loc. y = 7 - moveSequence[i]/8;
		ShowCellStateChange(loc, toWhat);
		i++;
	}

}



void COthelloView::OnViewAnimation() 
{
	// TODO: Add your command handler code here
	ShowTransition = !ShowTransition;
	Invalidate (false);
	
}

void COthelloView::OnViewIndicatepossiblemoves() 
{
	// TODO: Add your command handler code here
	IndicatePossibleMoves = !IndicatePossibleMoves;
	Invalidate (false);
	
}

void COthelloView::RefreshMoveList()
{
	CClientDC *pDC = new CClientDC(this);
/*
	CDC dcmem;
	dcmem.CreateCompatibleDC(pDC);
	CBitmap *oldBitmap=dcmem.SelectObject(&bmpBoard);
	
	//pDC->BitBlt( 420, 22, BitmapCellWidth,BitmapCellWidth,&dcmem,BitmapOffset.x, BitmapOffset.y, SRCCOPY);
	
	dcmem.SelectObject(&bmpBlob);
	pDC->BitBlt( 450, 22, BitmapCellWidth - 2,BitmapCellWidth - 2,&dcmem,BitmapCellWidth * 10 + 2, 2, SRCCOPY);	
	
	dcmem.SelectObject(oldBitmap);
	//CBrush * oldBrush 
	//pDC->Ellipse(450,10,450 + BitmapCellWidth, 10 + BitmapCellWidth);*/
	//pDC->SelectStockObject(BLACK_BRUSH);
	CBrush blackBrush, redBrush;
	redBrush.CreateSolidBrush(RGB(255,0,0));
	blackBrush.CreateSolidBrush(RGB(0,0,255));	

	CBrush *oldBrush  = pDC->SelectObject(&blackBrush);
	pDC->SelectStockObject(WHITE_PEN);
	pDC->Ellipse (450, 5, 470, 25);
	pDC->SelectObject(&redBrush);
	pDC->Ellipse (500, 5, 520, 25);
	//pDC->SetROP2(R2_XORPEN);
	pDC->SelectStockObject(NULL_BRUSH);
	
	switch(Game.GetCurrentPlayer())	{
	case BLACK:
		pDC->SelectStockObject(BLACK_PEN);
		pDC->Rectangle(450,5,470,25);
		pDC->SelectStockObject(WHITE_PEN);
		pDC->Rectangle(500,5,520,25);
		break;
	case WHITE:
		pDC->SelectStockObject(WHITE_PEN);
		pDC->Rectangle(450,5,470,25);
		pDC->SelectStockObject(BLACK_PEN);
		pDC->Rectangle(500,5,520,25);
		
		
		break;
	}
		
	pDC->SelectObject(oldBrush);
	blackBrush.DeleteObject();
	redBrush.DeleteObject();


	CString str;
	int x, y;
	x = 0;
	y = 0;
	str = Game.getPlayerName (BLACK);
	str = str.Left (8);
	str += " vs. ";
	str += Game.getPlayerName (WHITE);
	str.Left (21);
	pDC->TextOut (430,30, str);
	

	for (int index = 0; index < moveList.getMovesCompleted(); index++)
	{
		nPos move = moveList.getMove (index);
		x = move%8;
		y = 1 + move / 8;
		
		str.Format ("%c%d", 'A' + x, y); 
		x = index%2;
		y = index/2;
		if ( x == 0)
		{
			CString temp;
			temp.Format ("%d.  ", y + 1);
			str = temp + str + "       ";
		}
		
		pDC->TextOut (x * 100 + 425, y * 15 + 45, str); 
	}

}
