// OthelloView.h : interface of the COthelloView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_OTHELLOVIEW_H__FDA0A16C_EDA0_11D4_A788_444553540000__INCLUDED_)
#define AFX_OTHELLOVIEW_H__FDA0A16C_EDA0_11D4_A788_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "othellomain.h"
#include "playersettings.h"
#include "othello1.h"
#include "INCLUDE\all.h"	// Added by ClassView
#include "movelist.h"
class COthelloView : public CScrollView
{
	
protected: // create from serialization only
	COthelloView();
	DECLARE_DYNCREATE(COthelloView)

// Attributes
public:
	CBitmap bmpBoard;
	CBitmap bmpBlob;
	CPlayerSettings playerSettings;
	bool ShowTransition;
	bool IndicatePossibleMoves;
	CPoint BitmapOffset;
	int BitmapCellWidth;
	COthello Game;
	CMoveList moveList;

	TheBrain10 BrainForHint;

	COthelloDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COthelloView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:	
	void RefreshMoveList ();
	void AnimateMove (nID);
	nMoveLocation humanMove;
	bool waitingForHumanMove;
	void MainLoop ();
	void UpdateGameSettings();
	void ResetGame ();
	void ShowCellStateChange(CPoint location, nID toCellState);
	virtual ~COthelloView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(COthelloView)
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnOptionsPlayersettings();
	afx_msg void OnRadioPlayerAComputer();
	afx_msg void OnRadioPlayerAHuman();
	afx_msg void OnRadioPlayerBComputer();
	afx_msg void OnRadioPlayerBHuman();
	afx_msg void OnFileNew();
	afx_msg void OnViewAnimation();
	afx_msg void OnViewIndicatepossiblemoves();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in OthelloView.cpp
inline COthelloDoc* COthelloView::GetDocument()
   { return (COthelloDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_OTHELLOVIEW_H__FDA0A16C_EDA0_11D4_A788_444553540000__INCLUDED_)
