// TheBrain10.h: interface for the TheBrain10 class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_THEBRAIN10_H__0212BCEB_F1A4_11D4_A788_444553540000__INCLUDED_)
#define AFX_THEBRAIN10_H__0212BCEB_F1A4_11D4_A788_444553540000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "include/all.h"
#include "INCLUDE\all.h"	// Added by ClassView

class TheBrain10  
{

  private:
	int board[64];
	int me_id, you_id, empty_id;

	int to_play; // { +1, -1 } the player who has the turn
	int move_order_depth, depth, eg_empty;

	long int count; //no of leaves examined

	bool mem_err;

	int used_move_struc;
	char* start_move_struc;

	int max_depth, max_disks_turned, max_legal_moves;

	int total_disks;

	nMoveLocation order[60];
	nScore score_win, score_loss, score_draw;
	nScore start_alpha, start_beta;
	nScore cur_score;

	bool move_order_search;
	nScore eval_table[40];

	inline int set_up_legal_moves(char* move_struc);	//sets up legal moves in c and returns no of legal moves
	char* alloc_move_struc();
	void dealloc_move_struc();
	inline int disk_difference(nID to_play);
	inline void order_moves(int num_moves, char* move_struc, int* move_order);
	inline void play_move(char* move_struc, int movenum);
	inline void undo_move(char* move_struc, int movenum);

	nID opp(nID who) { return -who; }
	inline int strat_1(nID who);  //corner discs COMBINED with CONSECUTIVE
	inline int strat_3(nID who); //mobility
	inline int strat_4(nID who); //potential mobility
	inline int no_of_legal_moves(nID who);
	inline bool is_legal(nID who, nMoveLocation m);

	nScore evaluate(nScore alpha, nScore beta, int height);
	nScore stat_eval();


  public:
	TheBrain10();
	~TheBrain10();
	inline bool is_mem_err() // this must be the first function to be called
	{ return mem_err; }
	inline void set_id(int me, int you, int empty)   //set nID's used by the user interface
	{ me_id = me; you_id = you; empty_id=empty; }
	inline void set_depth(int d)	//set depth to be searched
	{ depth = d; }
	inline void set_endgame_empty(int d)	//set the start of endgame with d squares empty
	{ eg_empty = d; }

	nMoveLocation make_move(int* brd);
	nScore get_cur_score();
	long int get_leaves_evaluated() { return count; }

};

#endif // !defined(AFX_THEBRAIN10_H__0212BCEB_F1A4_11D4_A788_444553540000__INCLUDED_)
