#ifndef __BRAIN21__H__
#define __BRAIN21__H__
/*
	Gothello v1.0
	TheBrain v1.0
	TheBrain Header

	Work Started: 20/1/2001


*/
#include "all.h"
class TheBrain10
	{
  private:
	int board[64];
	int me_id, you_id, empty_id;

	int to_play; // { +1, -1 } the player who has the turn
	int move_order_depth, depth, eg_empty;

	long int count; //no of leaves examined

	bool mem_err;

	int used_move_struc;
	char* start_move_struc;

	int max_depth, max_disks_turned, max_legal_moves;

	int total_disks;

	movetype order[60];
	Score score_win, score_loss, score_draw;
	Score start_alpha, start_beta;
	Score cur_score;

	bool move_order_search;
	Score eval_table[40];

	inline int set_up_legal_moves(char* move_struc);	//sets up legal moves in c and returns no of legal moves
	char* alloc_move_struc();
	void dealloc_move_struc();
	inline int disk_difference(id to_play);
	inline void order_moves(int num_moves, char* move_struc, int* move_order);
	inline void play_move(char* move_struc, int movenum);
	inline void undo_move(char* move_struc, int movenum);

	id opp(id who) { return -who; }
	inline int strat_1(id who);  //corner discs COMBINED with CONSECUTIVE
	inline int strat_3(id who); //mobility
	inline int strat_4(id who); //potential mobility
	inline int no_of_legal_moves(id who);
	inline bool is_legal(id who, movetype m);

	Score evaluate(Score alpha, Score beta, int height);
	Score stat_eval();


  public:
	TheBrain10();
	~TheBrain10();
	bool is_mem_err();		// this must be the first function to be called
	inline void set_id(int me, int you, int empty);   //set id's used by the user interface
	inline void set_depth(int d);	//set depth to be searched
	inline void set_endgame_empty(int d);	//set the start of endgame with d squares empty
	inline void set_move_order_depth(int d);

	movetype make_move(int* brd);
	Score get_cur_score();
	long int get_leaves_evaluated() { return count; }

	};

#endif