				//class definitions for othello.cpp
//to be #include'd in othello.cpp
#ifndef __GAME_H_
#define __GAME_H_

class CDisplay
	{
 private:
	int grd_x, grd_y;
	int cell_wdth, cell_hgt;
	int piece_rad;
	int x1[4], y1[4], x2[4], y2[4]; //for lines to be displayed
	bool cleared[4];
	int size[4];
	bool show_turning;
	bool indi_pos_moves;
	int num_of_moves;

	color back_col;
	color piece_cols[3];
	color grd_back_col, grd_col;
	color talk_col[4];

 public:
	CDisplay();

	void set_line(int, char*);
	void clear_line(int);
	void set_turning(bool t) { show_turning = t; }
	void set_indi_pos_moves(bool t) { indi_pos_moves = t; }

	void set_num_moves(int t) { num_of_moves = t; }

	void show_score(score);
	void show_time(char*, long int, char*, long int);
	void show_num_of_pos_moves(int);
	void show_list_of_moves(movetype);

	void show_pos_move(pos);
	void unshow_pos_move(pos);

	void display_grid();
	void show_piece(pos, id);

	void turn_piece_to(pos, id);

	int get_loc(int, int);  //converts mouse screen coordinates to grid coordinates
	};

class board_class
	{
 private:
	int turn_delay, turn_snd_frq;
	pos board[64];

 public:
	board_class();

	void reset_board();
	pos* get_board() { return board; };

	void play_move(id, movetype);

	bool is_legal(id, movetype);
	int no_of_legal_moves(id);
	int no_of_pieces(id);
	bool is_filled();
	};

class CPlayer
	{
 private:
	char name[13];
	playertype nature;
	id plnumber;
	TheBrain10* brain; // if this player is computer
	long int elap_time;

	movetype get_comp_move();
	movetype get_human_move();

 public:
	CPlayer();

	void die();

	void set_name(char*);
	void set_nature(playertype, id, int depth, int eg_empty, int shallow_depth);
	char* get_name();
	long int get_elap_time();

	movetype get_move();
	};

class COthello
	{
	CPlayer player[3];

 public:
//	COthello();
	~COthello();

	int play_game();

	};


#endif